/*
   _____                       _____          _            
  / ____|                     |  __ \        | |           
 | (___  _   _ _ __   ___ _ __| |__) |___  __| |_   ___  __
  \___ \| | | | '_ \ / _ \ '__|  _  // _ \/ _` | | | \ \/ /
  ____) | |_| | |_) |  __/ |  | | \ \  __/ (_| | |_| |>  < 
 |_____/ \__,_| .__/ \___|_|  |_|  \_\___|\__,_|\__,_/_/\_\
              | |                                          
              |_|                               By Jana Sol
*/

//Credits:
//Jana Sol: Mod creator, SuperRework/SuperRedux creator
//BlueParasolKirby: Sol Form support and super cancelling
//Lunar: Allsuper.wad creator, the inspiration of this

//all characters can go super, with any music you want
//adding music is simple, just follow this template

//Hi, sol music doesnt currently work due to jankery with Sol forms forcing music changes

/*
PtOSuperRedux.AddSuperMusic({track = lump name as a string, name = the name you want the music to be called})
PtOSuperRedux.AddSolMusic({track = lump name as a string, name = the name you want the music to be called})
*/

if not PtOSuperRedux
	rawset(_G,"PtOSuperRedux",{})
end

PtOSuperRedux.supermusic = $ or {}
PtOSuperRedux.solmusic = $ or {}

PtOSuperRedux.AddSuperMusic = function(...) -- expects (track, name)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		table.insert(PtOSuperRedux.supermusic, v)
		print("PtOSR: Added "..v.name.." super music")
	end
end

PtOSuperRedux.AddSuperMusic(
	{
		track = "_SUPER",
		name = "vanilla"
	},
	{
		track = "SMSUPR",
		name = "sonicmania"
	},
	{
		track = "S3SUPR",
		name = "sonic3"
	},
	{
		track = "S2SUPR",
		name = "sonic2"
	},
	{
		track = "AVSUPR",
		name = "liveandlearn"
	}
)

PtOSuperRedux.AddSolMusic = function(...) -- expects (track, name)
	local packedargs = {...}
	for k, v in ipairs(packedargs) do
		table.insert(PtOSuperRedux.solmusic, v)
		print("PtOSR: Added "..v.name.." super music from")
	end
end

PtOSuperRedux.AddSolMusic(
	{
		track = "METAM",
		name = "default"
	}
)

local function UpdateConfig(p)
	local superbutton = "tossflag"
	if p.superbutton == BT_SPIN
		superbutton = "spin"
	elseif p.superbutton == BT_TOSSFLAG
		superbutton = "tossflag"
	elseif p.superbutton == BT_CUSTOM1
		superbutton = "custom1"
	elseif p.superbutton == BT_CUSTOM2
		superbutton = "custom2"
	elseif p.superbutton == BT_CUSTOM3
		superbutton = "custom3"
	end
	local supertoggle = "on"
	if p.supertoggle == 1 then supertoggle = "on" elseif p.supertoggle == 0 then supertoggle = "off" elseif p.supertoggle == 2 then supertoggle = "all" end
	local soltoggle = "on"
	if p.soltoggle == 1 then soltoggle = "on" elseif p.soltoggle == 0 then soltoggle = "off" elseif p.soltoggle == 2 then soltoggle = "all" end
	local supermusic = "vanilla"
	if p.supermusicname == 0 then supermusic = "off" else supermusic = p.supermusicname end
	local file = io.openlocal("client/PtOSuperReduxConfig.cfg", "w+")
	file:write("supertoggle "..tostring(supertoggle).."\nsoltoggle "..tostring(soltoggle).."\nsupermusic "..tostring(supermusic).."\nsuperbutton "..tostring(superbutton))
end

local loaded
local function LoadConfig()
	if not loaded then
		local file = io.openlocal("client/PtOSuperReduxConfig.cfg", "r")
		if file == nil then
			file = io.openlocal("client/PtOSuperReduxConfig.cfg", "w")
			if not file then
				print("A SuperRedux config couldn't be generated. Write permission issues?")
				print("[If you're seeing this in your dedi's server console, this is fine.]")
				loaded = true
			end
			print("\130A SuperRedux config was created.")
			print("\130Your settings will now be autosaved.")
			file:close()
		else
			if not consoleplayer then
				print("Tried to read PtOSuperReduxConfig.cfg, but there's no player to execute it with.")
				print("[If you're seeing this in your dedi's server console, this is fine.]")
				loaded = true
				return
			end
			print("\130A SuperRedux config was found. Loading, sit tight...")
			local buf = file:read()
			while buf do
				COM_BufInsertText(consoleplayer, buf)
				buf = file:read()
			end
			file:close()
		end
		loaded = true
	end
end
addHook("PlayerSpawn", LoadConfig)

local function supertoggle(p, arg) -- but why would you ever want to turn it off :(
	arg = tostring(arg):lower()
	if(arg == "on" or arg == "off" or arg == "all") then
		if(arg == "on") then 
			p.supertoggle = 1
		elseif(arg == "off") then 
			p.supertoggle = 0
		elseif(arg == "all") then
			p.supertoggle = 2
		end
		if(arg == "all") then
			CONS_Printf(p, "\131* Super forms have been toggled to \130ALL\131.")
		else
			CONS_Printf(p, "\131* Super forms have been toggled \130" .. arg:upper() .. "\131.")
		end
		UpdateConfig(p)
		S_StartSound(nil, sfx_radio, p)
	else
		CONS_Printf(p, "\135* Please choose between \130ON\135, \130OFF \135or \130ALL\135.")
		S_StartSound(nil, sfx_radio, p)
	end
end

local function soltoggle(p, arg) -- but why would you ever want to turn it off :(
	arg = tostring(arg):lower()
	if(arg == "on" or arg == "off" or arg == "all") then
		if(arg == "on") then 
			p.soltoggle = 1
		elseif(arg == "off") then 
			p.soltoggle = 0
		elseif(arg == "all") then
			p.soltoggle = 2
		end
		if(arg == "all") then
			CONS_Printf(p, "\131* Sol forms have been toggled to \130ALL\131.")
		else
			CONS_Printf(p, "\131* Sol forms have been toggled \130" .. arg:upper() .. "\131.")
		end
		UpdateConfig(p)
		S_StartSound(nil, sfx_radio, p)
	else
		CONS_Printf(p, "\135* Please choose between \130ON\135, \130OFF \135or \130ALL\135.")
		S_StartSound(nil, sfx_radio, p)
	end
end

local function supermusic(p, arg) 
	arg = tostring(arg):lower()
	local musicselected = false
	if arg == "off"
		p.supermusic = 0
		p.supermusicname = 0
	end
	for k, v in ipairs(PtOSuperRedux.supermusic) do
		if arg == PtOSuperRedux.supermusic[k].name
			p.supermusic = PtOSuperRedux.supermusic[k].track
			p.supermusicname = PtOSuperRedux.supermusic[k].name
			CONS_Printf(p, "\131* Super music has been changed to \130" .. PtOSuperRedux.supermusic[k].name:upper() .. "\131.")
			UpdateConfig(p)
			S_StartSound(nil, sfx_radio, p)
			musicselected = true
			return
		end
	end
	if musicselected == false
		local listOfMusics = ""
		for k, v in ipairs(PtOSuperRedux.supermusic) do
			listOfMusics = $..PtOSuperRedux.supermusic[k].name.."\n"
		end
		CONS_Printf(p, "\135* Selectable Super Themes are:\n\130"..listOfMusics:upper())
		
	end
end

local function solmusic(p, arg)
	arg = tostring(arg):lower()
	local musicselected = false
	if arg == "off"
		p.solmusic = 0
	end
	for k, v in ipairs(PtOSuperRedux.solmusic) do
		if arg == PtOSuperRedux.solmusic[k].name
			p.solmusic = PtOSuperRedux.solmusic[k].track
			CONS_Printf(p, "\131* Sol music has been changed to \130" .. PtOSuperRedux.solmusic[k].name:upper() .. "\131.")
			UpdateConfig(p)
			S_StartSound(nil, sfx_radio, p)
			musicselected = true
			return
		end
	end
	if musicselected == false
		local listOfMusics = ""
		for k, v in ipairs(PtOSuperRedux.solmusic) do
			listOfMusics = $..PtOSuperRedux.solmusic[k].name.."\n"
		end
		CONS_Printf(p, "Selectable Sol Themes are:\n"..listOfMusics:upper())
		
	end
end

local function superbutton(p, arg) -- but why would you ever want to not use tossflag :(
	arg = tostring(arg):lower()
	if(arg == "tossflag" or arg == "spin" or arg == "custom1" or arg == "custom2" or arg == "custom3") then
		if(arg == "tossflag") then 
			p.superbutton = BT_TOSSFLAG
		elseif(arg == "spin") then 
			p.superbutton = BT_SPIN
		elseif(arg == "custom1") then 
			p.superbutton = BT_CUSTOM1
		elseif(arg == "custom2") then 
			p.superbutton = BT_CUSTOM2
		elseif(arg == "custom3") then 
			p.superbutton = BT_CUSTOM3
		end 
		CONS_Printf(p, "\131* Super button has been changed to \130" .. arg:upper() .. "\131.")
		UpdateConfig(p)
		S_StartSound(nil, sfx_radio, p)
	else
		CONS_Printf(p, "\135* Please choose between \130TOSSFLAG\135, \130SPIN\135, \130CUSTOM1\135, \130CUSTOM2 \135or, \130CUSTOM3\135.")
		S_StartSound(nil, sfx_radio, p)
	end
end

local accountedSolchars = 0
local ogSolcharInfo = {}

addHook("MapLoad", function()
    if solchars then
        if accountedSolchars < #skins then
            for i = 0, accountedSolchars - 1 do
                if not ogSolcharInfo[skins[i].name] then
					for a = 0, #skins do
						solchars[skins[i].name][1] = skins[(i + 3 + a) % #skins].supercolor
						if solchars[skins[i].name][1] != skins[i].supercolor
							break
						end
					end
                end
            end
            for i = accountedSolchars, #skins - 1 do
                if solchars[skins[i].name] then
                    ogSolcharInfo[skins[i].name] = solchars[skins[i].name][2]
                    //print(p, "Found existing data for "..skins[i].realname.." containing the value: "..solchars[skins[i].name][2])
                    if solchars[skins[i].name][2] == 1 then
                        solchars[skins[i].name][2] = 2
                    end
                else
					for a = 0, #skins do
						solchars[skins[i].name] = {skins[(i + 3 + a) % #skins].supercolor, 2}
						if solchars[skins[i].name][1] != skins[i].supercolor
							break
						end
					end
                end
                //print(p, "Accounted for "..skins[i].realname)
            end
            accountedSolchars = #skins
        end
    end
end)

local superringrequirement = 50
local function superringrequirementfn (p, arg)
	arg = tonumber(arg)
	if arg then
		if(arg >= 1) then
			superringrequirement = arg
			if(arg == 1) then
				CONS_Printf(p, "\131You now need at least \1301 ring \131to use your Super Form. TOO EASY!")
			elseif(arg >= 250) then
				CONS_Printf(p, "\131You now need at least \130" .. tostring(arg) .. " rings \131to use your Super Form. Yeah, good luck with that, buddy.")
			else
				CONS_Printf(p, "\131You now need at least \130" .. tostring(arg) .. " rings \131to use your Super Form.")
			end
		else
			CONS_Printf(p, "\133That is not a valid ring amount!")
		end
	else
		CONS_Printf(p, "\130Sets the minimum number of rings required to activate your Super Form!")
	end
	S_StartSound(nil, sfx_radio, p)
end
local solringrequirement = 50
local function solringrequirementfn (p, arg)
	arg = tonumber(arg)
	if arg then
		if(arg >= 1) then
			solringrequirement = arg
			if(arg == 1) then
				CONS_Printf(p, "\131You now need at least \1301 ring \131to use your Sol Form. TOO EASY!")
			elseif(arg >= 250) then
				CONS_Printf(p, "\131You now need at least \130" .. tostring(arg) .. " rings \131to use your Sol Form. Yeah, good luck with that, buddy.")
			else
				CONS_Printf(p, "\131You now need at least \130" .. tostring(arg) .. " rings \131to use your Sol Form.")
			end
		else
			CONS_Printf(p, "\133That is not a valid ring amount!")
		end
	else
		CCONS_Printf(p, "\130Sets the minimum number of rings required to activate your Sol Form!")
	end
	S_StartSound(nil, sfx_radio, p)
end

COM_AddCommand("supertoggle", supertoggle, 0)

COM_AddCommand("soltoggle", soltoggle, 0)

COM_AddCommand("supermusic", supermusic, 0)

--COM_AddCommand("solmusic", solmusic, 0)

COM_AddCommand("superbutton", superbutton, 0)

COM_AddCommand("superringrequirement", superringrequirementfn, COM_ADMIN)

COM_AddCommand("solringrequirement", solringrequirementfn, COM_ADMIN)

addHook("ThinkFrame", function()
    for player in players.iterate do
		--print(S_MusicName())
		if player.solchar then
			if player.SolTransforming and player.rings >= superringrequirement and (player.supertoggle == 2 or player.supertoggle == 1 and player.nosuper == false) then
				player.solchar.spindown = (player.cmd.buttons & BT_SPIN)
			else
				player.solchar.spindown = true
			end
		end
		player.currentmusic = S_MusicName()
		if player.superbutton == nil then 
			player.superbutton = BT_TOSSFLAG 
		end
		if player.supermusic == nil then 
			player.supermusic = "_SUPER"
		end
		if player.solmusic == nil then 
			player.solmusic = "METAM"
		end
		if player.mo.skin == "inazuma" then
			if player.mo.state == S_ULTZUMA_TRANS1 or player.mo.state == S_ULTZUMA_TRANS2 then
				player.srultimate = true
			else
				player.srultimate = nil
			end
		else
			player.srultimate = nil
		end
		if (player.charflags & SF_SUPER) and player.powers[pw_super] == 0 and not player.srultimate
			player.charflags = $ & ~SF_SUPER
			player.powers[pw_super] = 0
		end
		if player.powers[pw_super] == 1 and not player.imcryingjana then
			player.imcryingjana = true
		elseif player.powers[pw_super] == 0 and player.imcryingjana then
			player.imcryingjana = nil
			COM_BufInsertText(player, "tunes -default")
		end
		if ogSolcharInfo[player.mo.skin] then
			if ogSolcharInfo[player.mo.skin] >= 2 then
				player.nosuper = false
			else
				player.nosuper = true
			end
		else
			player.nosuper = false
		end
		if player.transtimer == nil then
			player.transtimer = 0
		elseif player.transtimer > 0
			player.transtimer = $ - 1
		else
			player.transtimer = 0
		end
		if player.mo.skin == "supersonic" and player.powers[pw_super] == 0 //Super Sonic (character) completely breaks without this.
			player.charflags = $ | SF_SUPER
			player.powers[pw_super] = 1
		end
		//if player.supertoggle ~= 0 
			if player.cmd.buttons & player.superbutton and player.transtimer == 0 and not P_IsObjectOnGround(player.mo) and player.mo.skin != "supersonic" then
				if player.powers[pw_super] == 0 and not (player.solchar and player.solchar.istransformed > 0)
					if (player.soltoggle == 2 or player.soltoggle == 1 and ogSolcharInfo[player.mo.skin]) and player.solchar and player.solchar.hasallemeralds and player.rings >= solringrequirement then
						player.solchar.istransformed = 1
						player.solchar.spindowntwo = true
						player.mo.state = S_PLAY_SUPER_TRANS1
						S_StartSound(player.mo, sfx_secir)
						player.powers[pw_extralife] = 0
						player.powers[pw_sneakers] = 0
						player.powers[pw_invulnerability] = 0
						player.solchar.emeraldcircle = 1
						//if player.solmusic ~= 0 then COM_BufInsertText(player, "tunes "..player.solmusic) end
					elseif (player.supertoggle == 2 or player.supertoggle == 1 and not player.nosuper) and emeralds == 127 and player.rings >= superringrequirement and player.mo.skin != "adventuresonic" then
						player.charflags = $ | SF_SUPER
						player.powers[pw_super] = 1
						player.mo.state = S_PLAY_SUPER_TRANS1
						S_StartSound(player.mo, sfx_supert, player)
						if player.supermusic ~= 0 then COM_BufInsertText(player, "tunes "..player.supermusic) end
					else
						if not player.solchar or not ogSolcharInfo[player.mo.skin] and player.soltoggle == 1 or player.soltoggle == 0 or (player.nosuper == false or soltoggle != 2) and (not player.solchar.hasallemeralds or solringrequirement > superringrequirement and emeralds == 127) then
							//print(player, "Super Path")
							if emeralds == 127 and player.mo.skin != "adventuresonic" and player.supertoggle != 0 and not (player.nosuper == true and player.soltoggle == 0 and player.supertoggle != 2) then
								CONS_Printf(player, "\133You need \130" .. tostring(superringrequirement - player.rings) .. " more rings \133to use your Super Form.")
							end
						else
							//print(player, "Sol Path")
							if player.solchar.hasallemeralds then
								CONS_Printf(player, "\133You need \130" .. tostring(solringrequirement - player.rings) .. " more rings \133to use your Sol Form.")
							end
						end
					end
				elseif (player.solchar and player.solchar.istransformed > 0)
					player.solchar.earlyburncancel = true
				else
					player.powers[pw_super] = 0
					player.mo.color = player.skincolor
					P_SpawnShieldOrb(player)
					COM_BufInsertText(player, "tunes -default")
				end
				player.transtimer = 70
			end
		//end
	end
end)
